1 REM TAXMAN - first published in People's Computer Company
2 REM          vol. 2, no. 1 - September 1973
100 PRINT
102 PRINT
104 PRINT "Hi, I'm the taxman"
106 PRINT "Do you want the regulations (1=Yes, 0=No)";
108 INPUT r
110 IF r=1 THEN 900
120 REM *** initialization
122 GOSUB 800
124 REM *** the human takes a number
126 GOSUB 500
128 REM *** compute the human's and taxman's totals
130 GOSUB 570
132 REM *** print the new list
134 GOSUB 600
136 REM *** check if any numbers still have factors
138 GOSUB 650
140 IF m=1 THEN 126
142 REM *** find the winner
144 GOSUB 700
146 REM *** again?
148 GOTO 750
496 REM 
497 REM *** the human moves
498 REM
500 PRINT
502 PRINT
504 PRINT "You take";
506 INPUT k
508 LET k=INT(k)
510 IF k<=0 THEN 750
512 IF k<=n THEN 518
514 PRINT k;" is not in the list  --  try again."
516 GOTO 502
518 IF l(k)=0 THEN 514
520 REM  find all the factors
522 IF k>1 THEN 530
524 PRINT "There are no factors of ";k;" for me."
526 PRINT "Are you trying to short-change the taxman?"
528 GOTO 502
530 LET m=0
532 FOR i=1 TO k/2
534 IF l(i)=0 THEN 544
536 IF k <> i*INT(k/i) THEN 544
538 LET m=m+1
540 LET t(m)=i
542 LET l(i)=0
544 NEXT i
546 REM check whether there were any factors
548 IF m=0 THEN 524
550 LET l(k)=0
552 RETURN
566 REM
567 REM *** compute the human's and taxman's totals
568 REM
570 LET y=y+k
572 PRINT "Your total is ";y
574 PRINT "I get ";
576 FOR i=1 TO m
578 PRINT t(i);
580 LET z=z+t(i)
582 NEXT i
584 PRINT
586 PRINT "My total is ";z
588 RETURN
596 REM
597 REM *** print the new list
598 REM
600 PRINT
602 PRINT "New list: ";
604 LET m=0
606 FOR i=1 TO n
608 IF l(i)=0 THEN 614
610 PRINT i;
612 LET m=1
614 NEXT i
616 RETURN
646 REM
647 REM *** check if any numbers still have factors
648 REM
649 REM check if the list is empty
650 IF m=0 THEN 690
652 FOR i=n TO 4 STEP -1
654 FOR j=2 TO i/2
656 IF l(j)=0 THEN 664
658 IF i <> j*INT(i/j) THEN 664
660 LET m=1
662 RETURN
664 NEXT j
666 NEXT i
668 REM  the taxman gets the rest of the numbers
670 PRINT
672 PRINT "I get ";
674 FOR i=1 TO n
676 IF l(i)=0 THEN 682
678 PRINT i;
680 LET z=z+i
682 NEXT i
684 PRINT " because no factors of any number are left."
686 PRINT "My total is ";z
688 LET m=0
690 RETURN
696 REM
697 REM *** find the winner
698 REM
700 PRINT
702 IF z>y THEN 708
704 PRINT "You ";y;"     Taxman ";z;"    You win !!!"
706 RETURN
708 PRINT "Taxman ";z;"    You ";y;"    The taxman wins."
710 RETURN
746 REM 
747 REM *** again?
748 REM
750 PRINT
752 PRINT
754 PRINT "Again (1=yes, 0=no)";
756 INPUT r
759 IF r=0 THEN 999
760 GOTO 122
796 REM
797 REM *** initialization
798 REM
800 PRINT
802 PRINT "How many numbers do you want in the list";
804 INPUT n
806 LET n=INT(n)
808 IF n<=0 THEN 999
810 IF n<=50 THEN 816
812 PRINT "At this time, regulations allow a maximum of 50 numbers."
814 GOTO 800
816 DIM l(50), t(10)
818 LET y=0
820 LET z=0
822 PRINT
824 PRINT "The list is:";
826 FOR i=1 TO n
828 PRINT i;
830 LET l(i)=1
832 NEXT i
834 IF n>1 THEN 844
836 PRINT
838 PRINT "How very generous of you to forfeit all to the taxman."
840 PRINT "Taxman  1    You  0       The taxman wins."
842 GOTO 750
844 RETURN
896 REM
897 REM *** instructions
898 REM
900 PRINT
901 PRINT "You try to beat the taxman."
902 PRINT
904 PRINT "We start with a list of whole numbers in numerical"
906 PRINT "order (you decide how many)."
908 PRINT
910 PRINT "You take a number from the list -- the taxman gets"
912 PRINT "all the factors of your number that are still left."
914 PRINT "Your number and all of its factors are then deleted"
916 PRINT "from the list."
918 PRINT
920 PRINT "For example, suppose you want ten numbers to be in the list."
922 PRINT "Then the list would be: 1  2  3  4  5  6  7  8  9  10"
924 PRINT
926 PRINT "If you took 8, the taxman would get: 1, 2, and 4"
928 PRINT "and the new list would be: 3  5  6  7  9  10"
930 PRINT
932 PRINT "The taxman must get something every time so you can"
934 PRINT "only pick a number that has factors left."
936 PRINT
938 PRINT "When none of the remaining numbers has any factors,"
940 PRINT "the taxman gets them!!"
942 PRINT
944 PRINT "Your score is the sum of numbers you take."
946 PRINT "If you want to give up, take 0."
948 PRINT "Good luck !!!"
950 GOTO 122
999 END
